unit MiscBDE;

interface

uses
  DB, DBTables;

type
  TBDEUtils = class
  private
    FQueryUpdate: TQuery;
  protected
  public
    property QueryUpdate :TQuery read FQueryUpdate;
    procedure QueryUpdateOpen(ASql :String; DS :TDataSet = nil);
    procedure QueryUpdateOpenFmt(const FmtSql: string; const Args: array of const; DS :TDataSet = nil);
    procedure QueryUpdateExec(ASql :String; DS :TDataSet = nil);
    procedure QueryUpdateExecFmt(const FmtSql: string; const Args: array of const; DS :TDataSet = nil);
    constructor Create;
    destructor Destroy; override;
  end;

var
  BDEUtils :TBDEUtils;

implementation

uses SysUtils;

{ TBDEUtils }

constructor TBDEUtils.Create;
begin
  FQueryUpdate := TQuery.Create(nil);
end;

destructor TBDEUtils.Destroy;
begin
  QueryUpdate.Close;
  QueryUpdate.Free;
  inherited;
end;

procedure TBDEUtils.QueryUpdateExec(ASql: String; DS: TDataSet);
begin
  if not Assigned(DS) then DS := QueryUpdate;
  with DS as TQuery do begin
    Close;
    Sql.BeginUpdate;
    Sql.Clear;
    Sql.Add(ASql);
    Sql.EndUpdate;
    ExecSQL;
  end;
end;

procedure TBDEUtils.QueryUpdateExecFmt(const FmtSql: string;
  const Args: array of const; DS: TDataSet);
begin
  QueryUpdateExec(Format(FmtSql, Args), DS);
end;

procedure TBDEUtils.QueryUpdateOpen(ASql: String; DS: TDataSet);
begin
  if not Assigned(DS) then DS := QueryUpdate;
  with DS as TQuery do begin
    Close;
    Sql.BeginUpdate;
    Sql.Clear;
    Sql.Add(ASql);
    Sql.EndUpdate;
    Open;
  end;
end;

procedure TBDEUtils.QueryUpdateOpenFmt(const FmtSql: string;
  const Args: array of const; DS: TDataSet);
begin
  QueryUpdateOpen(Format(FmtSql, Args), DS);
end;

initialization
  BDEUtils := TBDEUtils.Create;

finalization
  FreeAndNil(BDEUtils);
  
end.
