unit UnitFormSectionTwo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UnitBaseMDIChildForm, Menus, ExtCtrls, DB, DBTables, Grids,
  DBGrids, StdCtrls, DBCtrls;

type
  TFormSectionTwo = class(TBaseMDIChildForm)
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Query1: TQuery;
    Panel1: TPanel;
    Query1event_id: TFloatField;
    Query1event_type_id: TIntegerField;
    Query1customer_id: TIntegerField;
    Query1event_series: TStringField;
    Query1event_serial: TIntegerField;
    Query1event_date: TDateField;
    Query1del: TBooleanField;
    Query1sum_r: TFloatField;
    Query1sum_0: TFloatField;
    Query1sum_1: TFloatField;
    Query1description: TStringField;
    Query1customer: TStringField;
    Query1event_type: TStringField;
    Panel2: TPanel;
    Label1: TLabel;
    DBText1: TDBText;
    OpenEvent1: TMenuItem;
    Query2: TQuery;
    Label3: TLabel;
    Label5: TLabel;
    Label2: TLabel;
    procedure CommandClick(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure Query1customerGetText(Sender: TField; var Text: String;
      DisplayText: Boolean);
  private
  protected
    procedure ProcessParams(const Value :Variant); override;
  public
    procedure DocInit; override;
  end;

//var
//  FormSectionTwo: TFormSectionTwo; //  .

implementation

uses
  Doc, RegisterFormConsts, MiscBDE;

{$R *.dfm}

{ TFormSectionTwo }

procedure TFormSectionTwo.DocInit;
begin
  inherited;
  Label2.Caption := Caption;
  Query1.Open;
  Query2.Open;
end;

procedure TFormSectionTwo.ProcessParams(const Value: Variant);
var
  V :Variant;
  N :Integer;
begin
  inherited;
  case Value[0] of
    1: begin
      with BDEUtils do begin
        QueryUpdate.DatabaseName := Query1.DatabaseName;
        QueryUpdateOpenFmt('SELECT event_type_id FROM event WHERE event_id = %d', [Round(Value[1])]);
        if QueryUpdate.RecordCount <= 0 then Exit;
        case QueryUpdate.Fields[0].AsInteger of
          1: N := iFormDocumentOne;
          6: N := iFormDocumentTwo;
        else
          raise Exception.Create('  ');
        end;
      end;
      if VarArrayHighBound(Value, 1) >= 2 then V := Value[2] else V := 0;
      DocManager.ShowDoc(N, [1, Value[1], Query2, V]);
    end;
    2: ;
    3: ;
    4: ;
  end;
end;

procedure TFormSectionTwo.CommandClick(Sender: TObject);
begin
  inherited;
  DocManager.ProcessDocParams(iFormSectionTwo, [1, Query1event_id.AsFloat]);
end;

procedure TFormSectionTwo.DBGrid1DblClick(Sender: TObject);
begin
  inherited;
  CommandClick(OpenEvent1);
end;

procedure TFormSectionTwo.Query1customerGetText(Sender: TField;
  var Text: String; DisplayText: Boolean);
begin
  inherited;
  case Sender.DataSet.FieldByName('event_type_id').AsInteger of
    1: Text := Sender.AsString;
    6: Text := '<' + Sender.DataSet.FieldByName('event_type').AsString + '>';
  else
    Text := Sender.AsString;
  end;
end;

end.
